angular.module('history.controller', [])

.controller('HistoryCtrl', ['$scope', '$stateParams', '$ionicHistory', 'load', '$timeout', function($scope, $stateParams, $ionicHistory, load, $timeout) {
    $scope.viewShowState = false;
    $scope.net_error_statue = false;
    $scope.title = "历史详细";
    $scope.dc = window.eval('(' + $stateParams.param + ')');
    // 3是作者，1是编辑部，2是专家
    $scope.roleMark = $scope.dc.roleMark;   // 1是责编，3是作者
    $scope.param =window.eval('(' + $scope.dc.dic + ')') ;
    $scope.back = function() {
        $ionicHistory.goBack(-1);
    };
    $scope.historyList = {
        processName: $scope.dc.historyStage,
        detailList: []
    };
    
    $scope.linkto = function() {
        navigator.intent.magazineRedOnline({ "file": $scope.param.url, "type": 1 });
    };
    $scope.readOnline = function(url) {
        navigator.intent.magazineRedOnline({ "file": url, "type": 0 });
    };

    console.log("scope.dc==>"+JSON.stringify($scope.dc));

    $scope.loadData = function() {
        if ($scope.param.status == "rejected") {
            var rejectReson = {
                title: "拒审原因",
                value: $scope.param.RejectReasonShow.rejectReson,
                type: "0",
                url: ""
            };
            var recommendation = {
                title: "2",
                value: "",
                type: "0",
                url: ""
            };
            var recommenderName = {
                title: "姓名",
                value: $scope.param.RejectReasonShow.recommenderName,
                type: "0",
                url: ""
            };
            var recommenderUnit = {
                title: "单位",
                value: $scope.param.RejectReasonShow.recommenderUnit,
                type: "0",
                url: ""
            };
            var recommenderTel = {
                title: "电话",
                value: $scope.param.RejectReasonShow.recommenderTel,
                type: "0",
                url: ""
            };
            var recommenderEmail = {
                title: "邮箱",
                value: $scope.param.RejectReasonShow.recommenderEmail,
                type: "0",
                url: ""
            };
            var recommenderEmail = {
                title: "备注",
                value: $scope.param.RejectReasonShow.recommenderEmail,
                type: "0",
                url: ""
            };
            $scope.historyList.detailList.push(rejectReson);
            $scope.historyList.detailList.push(recommendation);
            $scope.historyList.detailList.push(recommenderName);
            $scope.historyList.detailList.push(recommenderUnit);
            $scope.historyList.detailList.push(recommenderTel);
            $scope.historyList.detailList.push(recommenderEmail);
        } else {
            //window.alert(navigator.intent);
            load.show("正在加载中...");
            //$timeout(function() {
            var loop = function() {
                $timeout(function() {
                    if (navigator.intent) {
                        navigator.intent.historyDetail(function(json) {
                            /* body... */
                            load.hide();
                            //console.log("json222==>"+JSON.stringify(json)+"\n");
                            $scope.viewShowState = true;
                            $scope.pg = window.eval('(' + json + ')');
                            $scope.history = window.eval('(' + json + ')').pageview;
                            //$scope.data.pageView = [];
                            var obj0 = {title: "",value: "",show: true,type: "0",url: ""};
                            angular.forEach($scope.history, function(data, index, array) {
                                angular.forEach(data, function(item, temp, olddata) {
                                    var obj = {title: "",value: "",show: true,type: "0",url: ""};
                                    if (item.saveTable == 'PeerRemarkRec') {
                                        if (item.fieldname == "detailContent") {
                                            obj.title =item.displayname;
                                            var str = item.realValue;
 
                                            var arrEntities={'lt':'<','gt':'>','nbsp':' ','amp':'&','quot':'"'};
                                            str =  str.replace(/&(lt|gt|nbsp|amp|quot);/ig,function(all,t){return arrEntities[t];});
                                           
                                            obj.value= str.replace(/<[^<>]+?>/g,'');
                                            $scope.historyList.detailList.push(obj);
                                        }

                                        if (item.fieldname == "UploadFile") {
                                            angular.forEach($scope.pg.UploadFileList, function(item_, item_n, old_item) {
                                                var obj1 = {
                                                        title: item_.fileName,
                                                        value: "查看",
                                                        type: "1",
                                                        url: item_.url
                                                };
                                                $scope.historyList.detailList.push(obj1);
                                            });
                                        }
                                    }
                                    if (item.saveTable == 'WriteRoleSuggestRec') {
                                         if (item.fieldname == "suggest") {
                                             obj.title = "给责编看不给作者看";
                                             obj.value = item.realValue;
                                             obj.show = $scope.roleMark === '1';  // 当前角色为编辑部（1），该field才显示
                                             $scope.historyList.detailList.push(obj);
                                         }
                                    }
                                    if (item.saveTable == 'SingleFormRec') {
                                        if (item.fieldname == "singleFormID") {
                                            var refValue = item.refValue.split("|");
                                            var displayNames = item.displayNames.split("|");
                                            angular.forEach(refValue, function(id, i, old) {
                                                if (item.realValue == id) {
                                                    obj.value = displayNames[i];
                                                }
                                            });
                                            obj.title = "处理结果";

                                            $scope.historyList.detailList.push(obj);
                                        }
                                    }
                                    if (item.saveTable == 'CompositionRec') {

                                        if (item.fieldname == "year") {
                                            obj.title = "出版年";
                                            obj.value = JSON.parse($scope.pg.CompositionName).year;
                                            $scope.historyList.detailList.push(obj);
                                        } else if (item.fieldname == "issue") {
                                            obj.title = "出版期";
                                            obj.value = JSON.parse($scope.pg.CompositionName).issue;
                                            $scope.historyList.detailList.push(obj);
                                        } else if (item.fieldname == "col") {
                                            obj.title = "出版栏目";
                                            obj.value = JSON.parse($scope.pg.CompositionName).column;
                                             $scope.historyList.detailList.push(obj);
                                        }
                                    }
                                    if (item.saveTable == 'SelectedManRec') {
                                        if (item.fieldname == "selectMan") {
                                            obj.title = item.displayname;
                                            // obj.show = $scope.roleMark === '1';   // 作者和专家不予显示，也就是只有编辑部才显示  // 2020.12.11 由后台来判断
                                            var idL = item.realValue.split("|");
                                            angular.forEach(idL, function(id, i, old) {
                                                obj.value = obj.value + JSON.parse($scope.pg.SelectedManName)[id]+",";
                                            });
                                            $scope.historyList.detailList.push(obj);
                                        }

                                    }
                                    if (item.saveTable == 'PlanColumnRec') {
                                        //if (item.fieldname == "formID") {
                                            obj.title = item.displayname;
                                            obj.value = $scope.pg.PlanColumnName;
                                           
                                            $scope.historyList.detailList.push(obj);
                                    }

                                    // 审稿表格和word审稿单
                                    if ((item.saveTable == 'PeerFormRec' && item.fieldname == "nameString") || (item.saveTable == 'PeerFormUseWordRec' && item.fieldname == "htmlString")) {
                                        obj0.title = '评审专家意见';   // 因为.NET HTML没有做拆分，所以word审稿单和审稿表格统一为‘评审专家意见’；而实际上应该拆分，而且title为item.displayname;
                                        obj0.value = "查看";
                                        obj0.type = "2";
                                        if($scope.historyList.detailList.indexOf(obj0) === -1) $scope.historyList.detailList.push(obj0);
                                    }
                                    console.log("----->"+JSON.stringify($scope.historyList));
                                });
                            });
                        }, function(errorMsg) {
                            load.hide();
                            $scope.viewShowState = false;
                            $scope.net_error_statue = true;
                        }, { "url": $scope.dc.dic });
                    } else {
                        loop();
                    }
                }, 500);
            };
            loop();
        }
    };
    $scope.loadData();
}]);
